// testInfo.cxx
// Run IDD_INFOVIEW DIALOG

#include "testap3.h"
#include <process.h>
/* ===============
    LTEXT           "",IDD_NAME,68,10,85,8
    LTEXT           "",IDD_FORMAT,68,23,85,8
    LTEXT           "",IDD_WIDTH,68,36,85,8
    LTEXT           "",IDD_HEIGHT,68,49,85,8
    LTEXT           "",IDD_COLORS,68,62,85,8
    LTEXT           "",IDD_COMPRESS,68,75,85,8
  ================= */

static long Counter = 0;
static long Count2 = 0;
unsigned int threadID;
BOOL  bThreadExit = FALSE;

typedef struct tagTHDARGS {
   void * pDib;
   HWND   hDlg;
   size_t cnt;
}THDARGS, * PTHDARGS;

THDARGS sThdArgs;

size_t thdcount32BPP( PBYTE pb, size_t Width, size_t Height, size_t RWidth )
{
   size_t   cc = 0;
   BYTE  r,g,b;
   COLORREF cr;
   size_t mxcols = 5000;
   size_t x, y, i, xw;
   PDWORD   pdw;
   size_t sz = mxcols * sizeof(DWORD);
   pdw = (PDWORD)MALLOC(sz);
   if(!pdw)
      return 0;
   ZeroMemory(pdw,sz);
   r = 255;
   g = 255;
   b = 255;
   cr = RGB(r,g,b);
   for( y = 0; y < Height; y++ )
   {
      if( bThreadExit ) {
         cc = 0;
         break;
      }
      xw = 0;
      for( x = 0; x < Width; x++ )
      {
         r = *pb++;
         g = *pb++;
         b = *pb++;
         pb++;
         xw += 4; // each is 4 bytes
         cr = RGB(r,g,b);
         for( i = 0; i < cc; i++ )
         {
            if( pdw[i] == cr )
               break;
            if( bThreadExit ) {
               cc = 0;
               break;
            }
         }
         if( i == cc ) {
            pdw[i] = cr;
            cc++;
            if( cc >= mxcols )
            {
               PDWORD pdw2 = pdw;
               size_t sz2 = sz;
               mxcols += 5000;
               sz = mxcols * sizeof(DWORD);
               pdw = (PDWORD)MALLOC(sz);
               if(!pdw)
                  return 0;
               ZeroMemory(pdw,sz);
               memcpy(pdw, pdw2, sz2);
               MFREE(pdw2);   // delete OLD
            }
         }
         if( bThreadExit ) {
            cc = 0;
            break;
         }
      }
      while( xw < RWidth ) {
         if( bThreadExit ) {
            cc = 0;
            break;
         }
         pb++;
         xw++;
      }
      if( bThreadExit ) {
         cc = 0;
         break;
      }
   }
   MFREE(pdw);
   return cc;
}

size_t thdcount24BPP( PBYTE pb, size_t Width, size_t Height, size_t RWidth )
{
   size_t   cc = 0;
   BYTE  r,g,b;
   COLORREF cr;
   size_t mxcols = 5000;
   size_t x, y, i, xw;
   PDWORD   pdw;
   size_t sz = mxcols * sizeof(DWORD);
   pdw = (PDWORD)MALLOC(sz);
   if(!pdw)
      return 0;
   ZeroMemory(pdw,sz);
   r = 255;
   g = 255;
   b = 255;
   cr = RGB(r,g,b);
   for( y = 0; y < Height; y++ )
   {
      if( bThreadExit ) {
         cc = 0;
         break;
      }
      xw = 0;
      for( x = 0; x < Width; x++ )
      {
         r = *pb++;
         g = *pb++;
         b = *pb++;
         xw += 3;
         cr = RGB(r,g,b);
         for( i = 0; i < cc; i++ )
         {
            if( pdw[i] == cr )
               break;
            if( bThreadExit ) {
               cc = 0;
               break;
            }
         }
         if( i == cc ) {
            pdw[i] = cr;
            cc++;
            if( cc >= mxcols )
            {
               PDWORD pdw2 = pdw;
               size_t sz2 = sz;
               mxcols += 5000;
               sz = mxcols * sizeof(DWORD);
               pdw = (PDWORD)MALLOC(sz);
               if(!pdw)
                  return 0;
               ZeroMemory(pdw,sz);
               memcpy(pdw, pdw2, sz2);
               MFREE(pdw2);   // delete OLD
            }
         }
         if( bThreadExit ) {
            cc = 0;
            break;
         }
      }
      // get to END OF ROW OF BYTES
      while( xw < RWidth ) {
         if( bThreadExit ) {
            cc = 0;
            break;
         }
         pb++;
         xw++;
      }
      if( bThreadExit ) {
         cc = 0;
         break;
      }
   }
   MFREE(pdw);
   return cc;
}

unsigned __stdcall ThreadFunc( void * pArg )
{
   PTHDARGS pta = (PTHDARGS)pArg;
   if( pta && pta->hDlg && pta->pDib && IsWindow(pta->hDlg) &&
      ( ((LPBITMAPINFOHEADER)pta->pDib)->biSize == sizeof(BITMAPINFOHEADER) ) )
   {
      // GET DIB INFORMATION ...
      DWORD dwBPP   = DIBBitCount((PSTR)pta->pDib);
      size_t Width  = DIBWidth(pta->pDib);
      size_t Height = DIBHeight(pta->pDib);
      size_t RWidth = WIDTHBYTES( Width * dwBPP );  // this should be BYTE WIDTH
      PSTR pBits    = FindDIBBits((PSTR)pta->pDib);
      size_t cc = 0;
      // if GOT INFORMATION
      if( dwBPP && Width && Height && RWidth && pBits ) {
         if( bThreadExit )
            goto Thread_Exit;
         wsprintf( m_szTmpBuf, L"%d, but doing physical count ... moment ...",
               ((LPBITMAPINFOHEADER)pta->pDib)->biClrUsed );
         SetDlgItemText( pta->hDlg, IDD_COLORS, m_szTmpBuf);
         switch(dwBPP)
         {
         case 32:
            if( ((LPBITMAPINFOHEADER)pta->pDib)->biCompression == BI_BITFIELDS )
               pBits += (3 * sizeof(DWORD)); // bump PAST COLOR MASK (3)!!!
            // process as 4-byte color blocks
            cc = thdcount32BPP( (PBYTE)pBits, Width, Height, RWidth );
            break;
         case 24:
            // process as 3-byte color blocks
            cc = thdcount24BPP( (PBYTE)pBits, Width, Height, RWidth );
            break;
         }
         if( !bThreadExit ) {
            if(cc) {
               wsprintf( m_szTmpBuf, L"biClrUsed=%d, but has %d colors",
                  ((LPBITMAPINFOHEADER)pta->pDib)->biClrUsed,
                  cc );
            } else {
               wsprintf( m_szTmpBuf, L"biClrUsed=%d, and failed to get COUNT!",
                  ((LPBITMAPINFOHEADER)pta->pDib)->biClrUsed );
            }
            SetDlgItemText( pta->hDlg, IDD_COLORS, m_szTmpBuf);
         }
      }
      pta->cnt = cc;
   }

Thread_Exit:
   _endthreadex( 0xdeadfeed );
   return 0xdeadfeed;
} 


void LaunchColorCounter( PTHDARGS pta )
{
   // CreateThread(
   HANDLE hThread;
   bThreadExit = FALSE; // reset EXIT flag
   // Create the thread.
   hThread = (HANDLE)_beginthreadex( NULL, 0, &ThreadFunc, pta, 0, &threadID );
   if( hThread ) // Cleanup the thread object, but this does NOT kill the thread ...
      CloseHandle( hThread );
}


INT_PTR dlg_InfoInit( HWND hDlg )
{
   PTHDARGS pta = &sThdArgs;
   pta->cnt   = 0;
   pta->hDlg  = hDlg;
   pta->pDib  = m_hDIB;
   if( m_hDIB ) {
      SetDlgItemText( hDlg, IDD_NAME, m_szWinTitle );
      SetDlgItemInt( hDlg, IDD_WIDTH, (UINT)DIBWidth(m_hDIB), FALSE );
      SetDlgItemInt( hDlg, IDD_HEIGHT, (UINT)DIBHeight(m_hDIB), FALSE );
      SetDlgItemInt( hDlg, IDD_COLORS, (UINT)DIBNumColors((LPSTR)m_hDIB), FALSE);
      SetDlgItemInt( hDlg, IDD_COMPRESS, (UINT)DIBBitCount( (LPSTR)m_hDIB ), FALSE );
      SetDlgItemText( hDlg, IDD_FORMAT, DIBCompressionStg( m_hDIB ) );
      LaunchColorCounter( pta );
   } else {
      SetDlgItemText( hDlg, IDD_NAME, L"NO DIB LOADED" );
   }

   CenterWindow( hDlg, m_hMainWnd );
   return (INT_PTR)TRUE;
}

// Message handler for IDD_INFOVIEW box.
INT_PTR CALLBACK InfoView(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
      return dlg_InfoInit( hDlg );

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
         bThreadExit = TRUE;
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void Do_IDM_ACTIONINFO( HWND hWnd )
{
   if( m_hDIB )
      DialogBox(g_hInst, MAKEINTRESOURCE(IDD_INFOVIEW), hWnd, InfoView);

   bThreadExit = TRUE;
}


// eof - testInfo.cxx
