// testPaste.cxx

#include "testap3.h"

SIZE_T dwCopySize = 0;

HANDLE CopyHandle( HANDLE h )
{
	PINT8    lp;
	HANDLE   hCopy;
	size_t   dwLen;

	hCopy = NULL;
	if( !h )
      return hCopy;

   dwCopySize = GlobalSize( h );
   dwLen = dwCopySize; // = GlobalSize( h );
   if( dwLen )
	{
		//if( hCopy = DVGlobalAlloc( GHND, dwLen ) )
		hCopy = (HANDLE)MALLOC( dwLen );
		if( hCopy )
		{
		   // NOTE: is handle from CLIPBOARD
			lp = (PINT8)GlobalLock( h );
		   if( lp )
         {
#ifdef	WIN32
            memcpy( hCopy, lp, dwLen );
#else	// !WIN32
            {
               PINT8 lpCopy = (PINT8)hCopy;
			      while( dwLen-- )
                  *lpCopy++ = *lp++;	// Slow BYTE by BYTE copy
            }
#endif	// WIn32 y/n
            GlobalUnlock( h );	// Note: A Clipboard Handle, for ex.
         } else {
            MFREE(hCopy);
            hCopy = NULL;
         }
		}
	}
	return hCopy;
}

//HWND  HandlePasteClipboard( VOID )
void Do_IDM_EDITPASTE( HWND hWnd )
{
	HANDLE      hDIB;
	HBITMAP     hBitmap;
	HPALETTE    hPal;
   hDIB = 0;   // no DIB (device independant bitmap) yet
	// Open up the clipboard.  This routine assumes our app has
	//  the focus (which it should, as the user just picked the
	//  paste operation off the menu, and Windows is a non-preemptive
	//  system.  First we try for a DIB; if that's not available go
	//  for a bitmap (and a palette if one can be had).  Whatever
	//  format's available, we have to copy immediately (since the
	//  handle returned by GetClipboardData() belongs to the clipboard.
	//  Finally, go create the new MDI child window.
	if( OpenClipboard( GetFocus() ) )
	{
		if( IsClipboardFormatAvailable( CF_DIB ) )
		{
         // copy the GLOBAL to my memory
			hDIB = CopyHandle( GetClipboardData( CF_DIB ) );
         sprtf( "IDM_EDITPASTE: Got hDIB %p\n", hDIB );
		}
		else if( IsClipboardFormatAvailable( CF_BITMAP ) )
		{
         HANDLE hd;
			hBitmap = (HBITMAP)GetClipboardData( CF_BITMAP );
			if( IsClipboardFormatAvailable( CF_PALETTE ) )
				hPal = (HPALETTE)GetClipboardData( CF_PALETTE );
			else
				hPal = (HPALETTE)GetStockObject( DEFAULT_PALETTE );

			hd = DVBitmapToDIB( hBitmap, hPal );
         // copy the GLOBAL to my memory
         hDIB = CopyHandle(hd);
         sprtf( "IDM_EDITPASTE: Got BMP to DIB %p\n", hDIB );
		}
		else
		{
			//DIBError( ERR_NOCLIPFORMATS );
		}

		CloseClipboard();

      if( !hDIB )
         return;
         //goto Exit_Paste;

		//prd->rd_pTitle = gszRPTit;     // set TITLE file name
      //prd->rd_pPath  = gszRPNam;     // but keep the FULL NAME
		// The window title is of the form: "Clipboard1".  The
		//  number in the title is changed for each paste operation.
      // Get Next Name( &rd, &gszRPFrm[0], gnPasteNum++ );
      //DVNextRDName2( prd, &gszRPFrm[0], &gnPasteNum, &gbChgPaste );   // = "TEMPB%03d.BMP"

		// Perform the actual window opening.
		//prd->rd_hDIB    = hDIB;
		//prd->rd_Caller  = df_CLIPBRD;

		//OpenDIBWindow( hDIB, szTitle, df_CLIPBRD );
		//hWnd = OpenDIBWindow2( prd ); 
      {
         HDC hdc = GetDC(m_hMainWnd);
         if(hdc) {
            // paint DIB to window
            Process_DIB( m_hMainWnd, hDIB, hdc );
            ReleaseDC(m_hMainWnd, hdc);
            WriteBMPFile( L"tempbmp.bmp", hDIB );
            InvalidateRect(m_hMainWnd, NULL, TRUE);
         }
      }
#ifdef ADD_FILE_WRITE
		if(hWnd)
      {
         if( WriteBMPFile2( gszRPNam, hDIB, TRUE ) )
         {
#ifdef	CHGADDTO
            //AddToFileList( szTitle );
            ADD2LIST( prd );
#endif	// CHGADDTO
         }
      }
#endif // ADD_FILE_WRITE

	}
	else
	{
		//DIBError (ERR_CLIPBUSY);
	}

//Exit_Paste:

   //MFREE(prd);

   //return hWnd;

}	// End - void HandlePasteClipboard (void)

// eof - testPaste.cxx
