// testTest.cxx

//#include <Windows.h>
#include "testap3.h"
#include <math.h>
#include <strsafe.h>

static BOOL bUseBorder = TRUE;
static BOOL bAddScale = TRUE;
static BOOL bAddText = TRUE;
static BOOL bDrawThree = TRUE;

static double my_pi = 3.1415926535;
//static TCHAR _s_tmpbuf[1024+32];
//   hb2 = CreateSolidBrush(RGB(28, 255, 255));
COLORREF crWind = RGB(28, 255, 255);

POINT aptTriangle[4]  = {50,2, 98,86,  2,86, 50,2}, 
      aptRectangle[5] = { 2,2, 98,2,  98,98,  2,98, 2,2}, 
      aptPentagon[6]  = {50,2, 98,35, 79,90, 21,90, 2,35, 50,2}, 
      aptHexagon[7]   = {50,2, 93,25, 93,75, 50,98, 7,75, 7,25, 50,2}; 

// per origin
POINT ptInTri = { 50, 44 };
POINT ptInRect = { 50, 45 };
POINT ptInPent = { 21, 35 };
POINT ptInHex = { 70, 25 };
// per window
POINT ptInBez = { 336,416 };
POINT ptInBez2 = { 245, 500 };

POINT ptOffset = { 100, 100 };

POINT aptBez[5] = { 20,12, 88,246, 364,192, 250,48, 20,12 };
POINT aptBez2[5] = { 20,12, 88,246, 364,192, 250,48, 20,12 };
SIZE  aszCross = { 4, 4 };

void Put_Cross_AsIs( HDC hdc, PPOINT ppt )
{
   RECT rc;
   rc.left   = ppt->x - aszCross.cx;
   rc.right  = ppt->x + aszCross.cx;
   rc.top    = ppt->y - aszCross.cy;
   rc.bottom = ppt->y + aszCross.cy;
   DrawCrossHairs( hdc, &rc );
}

void Put_X_AsIs( HDC hdc, PPOINT ppt )
{
   RECT rc;
   rc.left   = ppt->x - aszCross.cx;
   rc.right  = ppt->x + aszCross.cx;
   rc.top    = ppt->y - aszCross.cy;
   rc.bottom = ppt->y + aszCross.cy;
   DrawDiagonals( hdc, &rc );
}

void Put_Cross( HDC hdc, PPOINT ppt )
{
   HPEN  hp;
   HPEN  hpOld = 0;
   hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      1, // int nWidth,        // pen width
      RGB(0,0,0) ); //  COLORREF crColor   // pen color
   if(hp)
      hpOld = (HPEN)SelectObject(hdc, hp);

   Put_Cross_AsIs( hdc, ppt );

   if(hpOld)
      SelectObject(hdc, hpOld);

   if(hp)
      DeleteObject(hp);
}


void Put_Cross_lines( HDC hdc, PPOINT ppt, int count )
{
   HPEN  hp;
   HPEN  hpOld = 0;
   RECT  rc;
   int   i;

   hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      1, // int nWidth,        // pen width
      RGB(0,0,0) ); //  COLORREF crColor   // pen color
   if(hp)
      hpOld = (HPEN)SelectObject(hdc, hp);

   Polyline( hdc, ppt, count );
   for( i = 0; i < count; i++ )
   {
      rc.left   = ppt[i].x - aszCross.cx;
      rc.right  = ppt[i].x + aszCross.cx;
      rc.top    = ppt[i].y - aszCross.cy;
      rc.bottom = ppt[i].y + aszCross.cy;
      DrawCrossHairs( hdc, &rc );
   }
   if(hpOld)
      SelectObject(hdc, hpOld);

   if(hp)
      DeleteObject(hp);
}

/* ====================================
VOID Example_FillEllipse3(HDC hdc)
{
   Graphics graphics(hdc);

   // Create a SolidBrush object.
   SolidBrush blackBrush(Color(255, 0, 0, 0));

   // Initialize the variables that define the ellipse.
   int x = 0;
   int y = 0;
   int width = 200;
   int height = 100;

   // Fill the ellipse.
   graphics.FillEllipse(&blackBrush, x, y, width, height);
}
   ====================================== */

void Do_PolyBezier(HDC hdc, PPOINT ppt, int cnt)
{
   RECT rc;
   HPEN  hp, hp2;
   HPEN  hpOld = 0;
   PPOINT ppt2 = &aptBez2[0];
   int   units, one;
   double yunit, yunits;

   PolyBezier(hdc, ppt, cnt);
   hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      1, // int nWidth,        // pen width
      RGB(0,0,255) ); //  COLORREF crColor   // pen color
   if(hp)
      hpOld = (HPEN)SelectObject(hdc, hp);

   // with BLUE pen
   memcpy( ppt2, ppt, sizeof(POINT) * cnt );
   rc.left = ppt2[0].x;
   rc.top  = ppt2[0].y;
   rc.right = ppt2[3].x;
   rc.bottom = ppt2[3].y;
   units = RECTWIDTH(&rc);
   yunit = (double)RECTHEIGHT(&rc) / (double)units;
   one = 1;
   while( one < units ) {
      yunits = yunit * (double)one;
      ppt2[0].x = ppt[0].x + one;
      ppt2[0].y = ppt[0].y + (int)(yunits + 0.5);
      hp2 = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
         1, // int nWidth,        // pen width
         RGB(one,0,(255-one)) ); //  COLORREF crColor   // pen color
      if(hp2)
         SelectObject(hdc, hp2);
      PolyBezier(hdc, ppt2, cnt);
      if(hp2)
         DeleteObject(hp2);
      one++;
   }

   if(hpOld)
      SelectObject(hdc, hpOld);

   if(hp)
      DeleteObject(hp);

}

void Do_GradientFill( HDC hdc )
{
   TRIVERTEX        vert [4] ;
   GRADIENT_TRIANGLE    gTRi[2];

   SetViewportOrgEx(hdc, ptOffset.x+300, ptOffset.y+0, NULL); 
   vert [0] .x       =  0;
   vert [0] .y       =  0;
   vert [0] .Red     =  0x0000;
   vert [0] .Green   =  0x0000;
   vert [0] .Blue    =  0x0000;
   vert [0] .Alpha   =  0x0000;

   vert [1] .x       =  200; //100;
   vert [1] .y       =  0;
   vert [1] .Red     =  0x0000;
   vert [1] .Green   =  0x0000;
   vert [1] .Blue    =  0xff00;
   vert [1] .Alpha   =  0x0000;

   vert [2] .x       =  200; //100;
   vert [2] .y       =  100; //32; 
   vert [2] .Red     =  0x0000;
   vert [2] .Green   =  0x0000;
   vert [2] .Blue    =  0xff00;
   vert [2] .Alpha   =  0x0000;

   vert [3] .x       =  0;
   vert [3] .y       =  100; //32;
   vert [3] .Red     =  0xff00;
   vert [3] .Green   =  0xff00;
   vert [3] .Blue    =  0xff00;
   vert [3] .Alpha   =  0x0000;

   gTRi[0].Vertex1   = 0;
   gTRi[0].Vertex2   = 1;
   gTRi[0].Vertex3   = 2;

   gTRi[1].Vertex1   = 0;
   gTRi[1].Vertex2   = 2;
   gTRi[1].Vertex3   = 3;

   GradientFill(hdc,vert,4,&gTRi,1,GRADIENT_FILL_TRIANGLE);

   SetViewportOrgEx(hdc, ptOffset.x+300, ptOffset.y+150, NULL); 
   vert [0] .x       =  0;
   vert [0] .y       =  0;
   vert [0] .Red     =  0xff00;
   vert [0] .Green   =  0x0000;
   vert [0] .Blue    =  0x0000;
   vert [0] .Alpha   =  0x0000;

   vert [1] .x       =  0;
   vert [1] .y       =  150;
   vert [1] .Red     =  0xff00;
   vert [1] .Green   =  0x0000;
   vert [1] .Blue    =  0x0000;
   vert [1] .Alpha   =  0x0000;

   vert [2] .x       =  200;
   vert [2] .y       =  0; 
   vert [2] .Red     =  0x0000;
   vert [2] .Green   =  0x0000;
   vert [2] .Blue    =  0x0000;
   vert [2] .Alpha   =  0x0000;

   vert [3] .x       =  200;
   vert [3] .y       =  0;
   vert [3] .Red     =  0xff00;
   vert [3] .Green   =  0xff00;
   vert [3] .Blue    =  0xff00;
   vert [3] .Alpha   =  0x0000;

   gTRi[0].Vertex1   = 0;
   gTRi[0].Vertex2   = 1;
   gTRi[0].Vertex3   = 2;

   gTRi[1].Vertex1   = 0;
   gTRi[1].Vertex2   = 2;
   gTRi[1].Vertex3   = 3;

   GradientFill(hdc,vert,4,&gTRi,1,GRADIENT_FILL_TRIANGLE);

}

typedef struct tagMYPTS {
   POINT ptMin, ptMax;
   TCHAR chr[1024];
   POINT pt[1];   // two sets of POINTS
   // followed by 3 sets of doubles
   //POINT aptSin[DIVS+2];
   //POINT aptCos[DIVS+2];
   //double adDegs[DIVS+2];
   //double adSin[DIVS+2];
   //double adCos[DIVS+2];
}MYPTS, * PMYPTS;

#define  DIVS  21*2
#define  VERT_EXAG   150.0
#define  X_SPACE  10
#define  Y_SPACE  10
#define MY_INT32_MAX 0x7fffffff

HFONT MyCreateFont( HWND hWnd, HDC hdc ) 
{ 
    CHOOSEFONT cf; 
    LOGFONT lf; 
    HFONT hfont; 
 
    // Initialize members of the CHOOSEFONT structure. 
 
    cf.lStructSize = sizeof(CHOOSEFONT); 
    cf.hwndOwner = hWnd;   // or NULL
    cf.hDC = hdc; // or (HDC)NULL; 
    cf.lpLogFont = &lf; 
    cf.iPointSize = 0; 
    cf.Flags = CF_SCREENFONTS; 
    cf.rgbColors = RGB(0,0,0); 
    cf.lCustData = 0L; 
    cf.lpfnHook = (LPCFHOOKPROC)NULL; 
    cf.lpTemplateName = (LPTSTR)NULL; 
    cf.hInstance = (HINSTANCE) NULL; 
    cf.lpszStyle = (LPTSTR)NULL; 
    cf.nFontType = SCREEN_FONTTYPE; 
    cf.nSizeMin = 0; 
    cf.nSizeMax = 0; 
 
    // Display the CHOOSEFONT common-dialog box. 
    ChooseFont(&cf); 
 
    // Create a logical font based on the user's 
    // selection and return a handle identifying 
    // that font. 
    hfont = CreateFontIndirect(cf.lpLogFont); 
    return (hfont); 
} 


HFONT Get_Font( HDC hdc )
{
   LOGFONT lf;
   LOGFONT * plf = &lf;
   HFONT hf;
   ZeroMemory( plf, sizeof(LOGFONT) );
   plf->lfHeight = -MulDiv( 8, GetDeviceCaps(hdc, LOGPIXELSY), 72 );
   //lstrcpy( &plf->lfFaceName[0], L"Courier New" );
   StringCbCopy( plf->lfFaceName, LF_FACESIZE, L"Courier New" );
   //plf->lfWeight = FW_BOLD;   // set BOLD font
   hf = CreateFontIndirect( plf );
   return hf;
}

void show_sine( HWND hWnd, HDC hdc )
{
   double x, xd, dx, c;
   double id;
   double ip = my_pi / (double)DIVS;
   PTSTR ps;
   RECT rc;
   //int len, j, k, y, maxy, xdi;
   int len, j, xk, y, xdi;
   SIZE  sz, sz1;
   PPOINT ppts_s, ppts_c;
   //PPOINT   ppts_s = &aptSin[0];
   //PPOINT   ppts_c = &aptCos[0];
   POINT pS, pE, pT, pN;
   HPEN hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      2, // int nWidth,        // pen width
      RGB(0,0,255) ); //  COLORREF crColor   // pen color
   HPEN hpg = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      2, // int nWidth,        // pen width
      RGB(255,255,0) ); //  COLORREF crColor   // pen color
   PMYPTS pmps = (PMYPTS) MALLOC( sizeof(MYPTS) +
      (sizeof(POINT) * 2 * (DIVS + 2)) +
      (sizeof(double) * (DIVS + 2) * 3) );
   double * paD; // = &_s_adDegs[0];
   double * paS;
   double * paC;
   PPOINT pptMax, pptMin;
   HFONT hfOld = 0;
   HFONT hf = Get_Font(hdc);

   if( !pmps )
      return;

   pptMax = &pmps->ptMax;
   pptMin = &pmps->ptMin;
   ps = &pmps->chr[0];
   ppts_s = &pmps->pt[0];
   // get to END OF POINTS (x2), to 3 sets of DOUBLE points
   ppts_c = &pmps->pt[(DIVS+2)*2];
   paD = (double *)ppts_c;
   paS = &paD[(DIVS+2)];
   paC = &paS[(DIVS+2)];
   ppts_c = &pmps->pt[DIVS+2];

   // set MAX and MIN
   pptMax->x = 0;
   pptMax->y = 0;
   pptMin->x = MY_INT32_MAX;
   pptMin->y = MY_INT32_MAX;

   dx = (180.0 / my_pi) * 10.0;

   GetWindowRect( hWnd, &rc );
   j = 0;
   xk = 0;
   id = 0.0;
   for(j = 0; j <= DIVS; j++) // for(i = 0; i <= my_pi; i += ip)
   {
      //adCos[j] = cos(i);
      paC[j] = cos(id);
      //x = adSin[j] = sin(i); // sin
      x = paS[j] = sin(id); // sin
      xdi = (int)((id * dx) + 0.5);
      xd = (double)xdi / 10.0;
      while( xd > 360.0 )
         xd -= 360.0;
      //adDegs[j] = xd;   // Keep degrees
      paD[j] = xd;
      ppts_s[j].x = xk;
      y = (int) ((x * VERT_EXAG) + 0.5);
      ppts_s[j].y = y;    // set the y coordinate
      // set MIN points
      if( xk < pptMin->x )
         pptMin->x = xk;
      if( y < pptMin->y )
         pptMin->y = y;
      // set MAX points
      if( xk > pptMax->x )
         pptMax->x = xk;
      if( y > pptMax->y )
         pptMax->y = y;

      ppts_c[j].x = xk;  // set X
      //y = (int) ((adCos[j] * VERT_EXAG) + 0.5);
      y = (int) ((paC[j] * VERT_EXAG) + 0.5);
      ppts_c[j].y = y;
      // set MIN points
      if( xk < pptMin->x )
         pptMin->x = xk;
      if( y < pptMin->y )
         pptMin->y = y;
      // set MAX points
      if( xk > pptMax->x )
         pptMax->x = xk;
      if( y > pptMax->y )
         pptMax->y = y;

      xk += X_SPACE;  // move to RIGHT
      //if( y > maxy )
      //   maxy = y;

      id += ip; // bump to NEXT degrees
   }

   if(hf)
      hfOld = (HFONT)SelectObject(hdc, hf);

   // just SHOW the TEXT stuff
   if( bAddText ) {
      COLORREF crOldBak = SetBkColor(hdc,           // handle to DC
         crWind ); // background color value
      // establish a LEFT point to start text
      id = 10.471976;   // my_pi - 1.1234;
      x = sin( id );
      c = cos( id );
      xdi = (int)((id * dx) + 0.5);
      xd = (double)xdi / 10.0;
      StringCbPrintf(ps, 1024, L" a(%f) s=%f c=%f (%0.1f D) ", id, x, c, xd);
      len = lstrlen(ps);
      GetTextExtentPoint(hdc, ps, len, &sz);
      StringCbPrintf(ps, 1024, L"%u", 5); // one numeral
      len = lstrlen(ps);
      GetTextExtentPoint(hdc, ps, len, &sz1);   // size of ONE
      rc.left = rc.right - (sz.cx) - X_SPACE;
      rc.top += sz.cy;
      id = 0.0;
      for(j = 0; j <= DIVS; j++)
      {
         //x = adSin[j];
         x = paS[j];
         //c = adCos[j]; 
         c = paC[j]; 
         //xd = adDegs[j];
         xd = paD[j];
         StringCbPrintf(ps, 1024, L" a(%f) s=%f c=%f (%0.1f D) ", id, x, c, xd);
         len = lstrlen(ps);
         TextOut( hdc, rc.left, rc.top, ps, len );
         rc.top += sz.cy;
         if( rc.top > rc.bottom ) {
            break;
         }
         id += ip; // bump to NEXT degrees
      }
      SetBkColor(hdc,           // handle to DC
         crOldBak ); // background color value
   }

   // ==============================================================
   // DRAW A GRAPH

   // establish UPPER LEFT boundary
   SetViewportOrgEx(hdc, ptOffset.x+400, ptOffset.y+300, NULL); 

   for( j = 0; j <= DIVS; j++ ) {
      //Put_Cross_AsIs(hdc, &ppts_s[j] );
      Put_X_AsIs(hdc, &ppts_s[j] );
   }

   // NOTE: cPoints
   // [in] Specifies the number of points in the lppt array.
   // This value must be one more than three times the number of curves
   // to be drawn, because each Bzier curve requires two control points
   // and an endpoint, and the initial curve requires an additional
   // starting point. 
   PolyBezier(hdc, ppts_s, DIVS+1);
   // nearly the SAME as ...
   //Polyline(hdc, ppts_s, DIVS+1);

   // switch to YELLOW
   // COSINE GRAPH
   // ============
   if(hpg)
      SelectObject(hdc,hpg);
   for( j = 0; j <= DIVS; j++ ) {
      //Put_Cross_AsIs(hdc, &ppts_c[j] );
      Put_X_AsIs(hdc, &ppts_c[j] );
   }
   PolyBezier(hdc, ppts_c, DIVS+1);

   // ADD GRAPH AXIS
   // ==============
   if(hp)   // switch to BLUE line
      SelectObject(hdc,hp);

   // vertical, on right side plus Y_SPACE
   pS.x = pptMax->x + X_SPACE;   // k;
   pS.y = pptMin->y;
   pE.x = pS.x;
   pE.y = pptMax->y + Y_SPACE;   // maxy + Y_SPACE;
   DrawLine( hdc, &pS, &pE );

   // horizontal
   pS.x = pptMin->x; //0;
   pS.y = pptMax->y + Y_SPACE;   //maxy + Y_SPACE;
   pE.x = pptMax->x + X_SPACE;   // k;
   pE.y = pS.y;   // maxy + Y_SPACE;
   DrawLine( hdc, &pS, &pE );
   pN = pS;

   if( bAddScale ) {
      // horizontal SCALE
      // ****************
      pS.x = pptMin->x; //0;
      pS.y = pptMax->y + Y_SPACE;   //maxy + Y_SPACE;
      for( j = 0; j <= DIVS; j++ )
      {
         Put_Cross_AsIs( hdc, &pS );
         //xd = adDegs[j];   // get degrees
         xd = paD[j];   // get degrees
         StringCbPrintf(ps, 1024, L"%0.1f", xd);
         len = lstrlen(ps);
         GetTextExtentPoint(hdc, ps, len, &sz);
         pT = pS; // copy position
         if( j == 0 ) {
            pT.x -= sz.cx / 2;
            pT.y += sz.cy;
            TextOut( hdc, pT.x, pT.y, ps, len );
            pN = pT;
            pN.x += sz.cx + sz1.cx;
            pT.x += sz.cx / 2;
            DrawLine( hdc, &pT, &pS );
         } else {
            pT.x -= sz.cx / 2;
            pT.y += sz.cy;
            if( pT.x > pN.x ) {
               TextOut( hdc, pT.x, pT.y, ps, len );
               pN = pT;
               pN.x += sz.cx + sz1.cx;
               pT.x += sz.cx / 2;
               DrawLine( hdc, &pT, &pS );
            }
         }
         pS.x += X_SPACE;
      }
      pS.x = pptMin->x; //0;
      pS.y = pptMax->y + Y_SPACE + Y_SPACE + (sz.cy*2); //maxy + Y_SPACE + (sz.cy*2);
      StringCbPrintf(ps, 1024, L"Degrees");
      len = lstrlen(ps);
      GetTextExtentPoint(hdc, ps, len, &sz);
      pT = pS;
      pT.x = ((pptMax->x + X_SPACE - pptMin->x - sz.cx) / 2);  //(k - sz.cx) / 2;
      TextOut( hdc, pT.x, pT.y, ps, len );

      // vertical SCALE
      // **************
      if( bDrawThree ) {
         // draw at MIN = -1, 0 = 0, MAX = 1 on Y
         pS.x = pptMax->x + X_SPACE;   // k;
         pS.y = pptMin->y;
         Put_Cross_AsIs( hdc, &pS );
         pT = pS;
         StringCbPrintf(ps, 1024, L"-%u", 1);
         len = lstrlen(ps);
         GetTextExtentPoint(hdc, ps, len, &sz);
         pT.x += X_SPACE;
         pT.y -= sz.cy / 2;
         TextOut( hdc, pT.x, pT.y, ps, len );
         pT.y += sz.cy / 2;
         DrawLine( hdc, &pT, &pS );

         pS.y = 0;
         Put_Cross_AsIs( hdc, &pS );
         pT = pS;
         StringCbPrintf(ps, 1024, L" %u", 0);
         len = lstrlen(ps);
         GetTextExtentPoint(hdc, ps, len, &sz);
         pT.x += X_SPACE;
         pT.y -= sz.cy / 2;
         TextOut( hdc, pT.x, pT.y, ps, len );
         pT.y += sz.cy / 2;
         DrawLine( hdc, &pT, &pS );

         pS.y = pptMax->y;
         Put_Cross_AsIs( hdc, &pS );
         pT = pS;
         StringCbPrintf(ps, 1024, L"+%u", 1);
         len = lstrlen(ps);
         GetTextExtentPoint(hdc, ps, len, &sz);
         pT.x += X_SPACE;
         pT.y -= sz.cy / 2;
         TextOut( hdc, pT.x, pT.y, ps, len );
         pT.y += sz.cy / 2;
         DrawLine( hdc, &pT, &pS );

      } else {
         //i = (double)maxy / (double)DIVS;
         id = (double)(pptMax->y + Y_SPACE) / (double)DIVS;
         pS.x = pptMax->x + X_SPACE;   // k;
         pS.y = 0;
         for( j = 0; j < DIVS; j++ )
         {
            pS.y = (int)(( id * (double)j ) + 0.5);
            //Put_Cross_AsIs( hdc, &pS );
            pT = pS; // copy position
            if( j == 0 ) {
               Put_Cross_AsIs( hdc, &pS );
               StringCbPrintf(ps, 1024, L"%u", 0);
               len = lstrlen(ps);
               GetTextExtentPoint(hdc, ps, len, &sz);
               pT.x += X_SPACE;
               pT.y -= sz.cy / 2;
               TextOut( hdc, pT.x, pT.y, ps, len );
               pN = pT;
               pN.x += sz.cx + sz1.cx;
               pT.y += sz.cy / 2;
               DrawLine( hdc, &pT, &pS );
            } else if ((j + 1) == DIVS) {
               Put_Cross_AsIs( hdc, &pS );
               StringCbPrintf(ps, 1024, L"%u", 1);
               len = lstrlen(ps);
               GetTextExtentPoint(hdc, ps, len, &sz);
               pT.x += X_SPACE;
               pT.y -= sz.cy / 2;
               TextOut( hdc, pT.x, pT.y, ps, len );
               pT.y += sz.cy / 2;
               DrawLine( hdc, &pT, &pS );
            }
         }

         {
            COLORREF crold = SetTextColor(hdc, RGB(255,0,0));
            StringCbPrintf(ps, 1024, L"Sine");
            len = lstrlen(ps);
            GetTextExtentPoint(hdc, ps, len, &sz);
            // pS.y contains largest y, for marks
            // pN.x is end of last plus one
            pT.x = pN.x;   // get horizontal position
            pT.y = (pS.y - (sz.cy * len)) / 2;
            for( j = 0; j < len; j++ ) {
               TextOut( hdc, pT.x, pT.y, &ps[j], 1 );
               pT.y += sz.cy;
            }
            SetTextColor(hdc, crold);
         }
      }
   }

   if(hp)
      DeleteObject(hp);
   if(hpg)
      DeleteObject(hpg);
   if(hfOld)
      SelectObject(hdc, hfOld);
   if(hf)
      DeleteObject(hf);

   MFREE( pmps );
}


void Paint_Test( HWND hWnd, HDC hdc )
{
   RECT rc;
   POINT pt, pt2;
   HPEN  hp;
   HPEN  hpOld = 0;
   HBRUSH hb, hb2;
   HBRUSH hbOld = 0;

   DrawEllipseOutline( hdc, 80, 80, 60 );


   hp = CreatePen( PS_SOLID,  // int fnPenStyle,    // pen style
      2, // int nWidth,        // pen width
      RGB(255,0,0) ); //  COLORREF crColor   // pen color

   // Create a BLUEISH brush.
   hb = CreateSolidBrush(RGB(128, 128, 255));

   if(hp)
      hpOld = (HPEN)SelectObject(hdc, hp);
   if(hb)
      hbOld = (HBRUSH)SelectObject(hdc, hb);

   SetRect(&rc, 0, 0, 100, 100); 

   SetViewportOrgEx(hdc, ptOffset.x, ptOffset.y, &pt); 
   if (RectVisible(hdc, &rc)) {
       Polyline(hdc, aptTriangle, 4);
       if( bUseBorder ) {
          ExtFloodFill( hdc,          // handle to DC
             ptInTri.x, // int nXStart,      // starting x-coordinate 
             ptInTri.y, // int nYStart,      // starting y-coordinate 
             RGB(255,0,0), //COLORREF crColor, // fill color
             FLOODFILLBORDER );  // UINT fuFillType   // fill type
       } else {
          ExtFloodFill( hdc,          // handle to DC
             ptInTri.x, // int nXStart,      // starting x-coordinate 
             ptInTri.y, // int nYStart,      // starting y-coordinate 
             RGB(255,255,255), //COLORREF crColor, // fill color
             FLOODFILLSURFACE );  // UINT fuFillType   // fill type
       }
       Put_Cross( hdc, &ptInTri );
   }

   SetViewportOrgEx(hdc, ptOffset.x+100, ptOffset.y+0, NULL); 
   if (RectVisible(hdc, &rc)) {
      Polyline(hdc, aptRectangle, 5);
      hb2 = CreateSolidBrush(RGB(128, 255, 128));
      if(hb2)
         SelectObject(hdc, hb2);
      ExtFloodFill( hdc,          // handle to DC
         ptInRect.x, // int nXStart,      // starting x-coordinate 
         ptInRect.y, // int nYStart,      // starting y-coordinate 
         RGB(255,0,0), //COLORREF crColor, // fill color
         FLOODFILLBORDER );  // UINT fuFillType   // fill type
      if(hb2)
         DeleteObject(hb2);
      Put_Cross( hdc, &ptInRect );
   }
   SetViewportOrgEx(hdc, ptOffset.x+0, ptOffset.y+100, NULL); 
   if (RectVisible(hdc, &rc)) {
      Polyline(hdc, aptPentagon, 6);
      hb2 = CreateSolidBrush(RGB(255, 128, 128));
      if(hb2)
         SelectObject(hdc, hb2);
      ExtFloodFill( hdc,          // handle to DC
         ptInPent.x, // int nXStart,      // starting x-coordinate 
         ptInPent.y, // int nYStart,      // starting y-coordinate 
         RGB(255,0,0), //COLORREF crColor, // fill color
         FLOODFILLBORDER );  // UINT fuFillType   // fill type
      if(hb2)
         DeleteObject(hb2);
      Put_Cross( hdc, &ptInPent );
   }

   SetViewportOrgEx(hdc, ptOffset.x+100, ptOffset.y+100, NULL); 
   if (RectVisible(hdc, &rc)) {
      Polyline(hdc, aptHexagon, 7);
      hb2 = CreateSolidBrush(RGB(255, 255, 28));
      if(hb2)
         SelectObject(hdc, hb2);
      ExtFloodFill( hdc,          // handle to DC
         ptInHex.x, // int nXStart,      // starting x-coordinate 
         ptInHex.y, // int nYStart,      // starting y-coordinate 
         RGB(255,0,0), //COLORREF crColor, // fill color
         FLOODFILLBORDER );  // UINT fuFillType   // fill type
      if(hb2)
         DeleteObject(hb2);
      Put_Cross( hdc, &ptInHex );
   }

   SetViewportOrgEx(hdc, ptOffset.x+0, ptOffset.y+200, NULL); 
   if (RectVisible(hdc, &rc)) {
      Put_Cross_lines( hdc, aptBez, 5 );
      Do_PolyBezier(hdc, aptBez, 4);
      hb2 = CreateSolidBrush(RGB(255, 255, 28));
      if(hb2)
         SelectObject(hdc, hb2);
      pt2.x = ptInBez.x - ptOffset.x;
      pt2.y = ptInBez.y - (ptOffset.y+200);
      ExtFloodFill( hdc,          // handle to DC
         pt2.x, // int nXStart,      // starting x-coordinate 
         pt2.y, // int nYStart,      // starting y-coordinate 
         RGB(255,255,255), //COLORREF crColor, // fill color
         FLOODFILLSURFACE );  // UINT fuFillType   // fill type
      if(hb2)
         DeleteObject(hb2);
      Put_Cross( hdc, &pt2 );

      hb2 = CreateSolidBrush(RGB(28, 255, 28));
      if(hb2)
         SelectObject(hdc, hb2);
      pt2.x = ptInBez2.x - ptOffset.x;
      pt2.y = ptInBez2.y - (ptOffset.y+200);
      ExtFloodFill( hdc,          // handle to DC
         pt2.x, // int nXStart,      // starting x-coordinate 
         pt2.y, // int nYStart,      // starting y-coordinate 
         RGB(255,255,255), //COLORREF crColor, // fill color
         FLOODFILLSURFACE );  // UINT fuFillType   // fill type
      if(hb2)
         DeleteObject(hb2);
      Put_Cross( hdc, &pt2 );
   }
   Do_GradientFill(hdc);

   SetViewportOrgEx(hdc, pt.x, pt.y, NULL); 
   hb2 = CreateSolidBrush(crWind);  // RGB(28, 255, 255));
   if(hb2)
      SelectObject(hdc, hb2);
   pt2.x = 2;
   pt2.y = 2;
   ExtFloodFill( hdc,          // handle to DC
      pt2.x, // int nXStart,      // starting x-coordinate 
      pt2.y, // int nYStart,      // starting y-coordinate 
      RGB(255,255,255), //COLORREF crColor, // fill color
      FLOODFILLSURFACE );  // UINT fuFillType   // fill type
   if(hb2)
      DeleteObject(hb2);
   Put_Cross( hdc, &pt2 );

   SelectObject(hdc, hp);
   SelectObject(hdc, hb);
   show_sine( hWnd, hdc );

   if(hpOld)
      SelectObject(hdc, hpOld);
   if(hbOld)
      SelectObject(hdc, hbOld);

   if(hp)
      DeleteObject(hp);
   if(hb)
      DeleteObject(hb);
}


// eof - testTest.cxx
