// testWrite.cxx

#include "testap3.h"

//extern SIZE_T dwCopySize;

// NOTE: This is NOT a GlobalAlloc (HGLOBAL), but actually
// just a memory pointer. It was allocated using 'new' ...
BOOL  WriteBMPFile( PTSTR pf, HANDLE hDIB )
{
   BOOL                 flg = FALSE;
   FILE *               fh;
	BITMAPFILEHEADER	   hdr;
	LPBITMAPINFOHEADER   lpbi;
   SIZE_T               dws, dwis;
   if( !hDIB || !pf )
      return flg;

   // ===================================================================
   lpbi = (LPBITMAPINFOHEADER)hDIB;  // CAST DIB HANDLE TO WHAT IT IS ...
   // ===================================================================

   dws = lpbi->biSizeImage;   // extract IMAGE SIZE, and COMPUTE IMAGE SIZE
   dwis = WIDTHBYTES(lpbi->biWidth*lpbi->biBitCount) * lpbi->biHeight;
   if( dws != dwis ) // computed versus calculated should be the SAME!!!
      return flg;

   // add to IMAGE SIZE
   dws += lpbi->biSize +    // size of 	LPBITMAPINFOHEADER
          PaletteSize((LPSTR)lpbi ); // plus PALETTE (if any)

   //if( dws < dwCopySize )
   //   dws = dwCopySize; // update to this SIZE
   // Fill in the fields of the file header
   ZeroMemory( &hdr, sizeof(BITMAPFILEHEADER) );
   hdr.bfType		 = DIB_HEADER_MARKER;
   hdr.bfReserved1 = 0;
   hdr.bfReserved2 = 0;
   hdr.bfOffBits   = (DWORD)sizeof(BITMAPFILEHEADER) +   // file header plus
                        lpbi->biSize +    // size of 	LPBITMAPINFOHEADER
                        PaletteSize((LPSTR)lpbi ); // plus PALETTE (if any)
   hdr.bfSize		 = (DWORD)(dws + sizeof (BITMAPFILEHEADER));
   // CREATE the OUTPUT FILE
   // ======================
   fh = _wfopen( pf, L"wb" );
   if( fh ) {
      // write header to file
      if( fwrite( &hdr, 1, sizeof(BITMAPFILEHEADER), fh ) ==
         sizeof( BITMAPFILEHEADER ) ) {
         // write the DATA BLOCK, after the FILE HEADER
         if( fwrite( lpbi, 1, dws, fh ) == dws ) {
            flg = TRUE; // written DIB to Windows BMP file
         }
      }
      fclose(fh);
   }
   return flg;
}

BOOL  WriteBMPFile_ANSI( PTSTR pf, HANDLE hDIB )
{
   BOOL                 flg = FALSE;
   FILE *               fh;
	BITMAPFILEHEADER	   hdr;
	LPBITMAPINFOHEADER   lpbi;
   DWORD                dws, dwis;
   PSTR                 ps;   // = (PSTR)MALLOC(1024);
   size_t               len = lstrlen(pf);
   int                  ret;

   if( !hDIB )
      return flg;
   if( !len )
      return flg;

   ps = (PSTR)MALLOC(264);
   if( !ps )
      return flg;

   lpbi = (LPBITMAPINFOHEADER)hDIB;  // CAST DIB HANDLE TO WHAT IT IS ...
   dws = lpbi->biSizeImage;
   dwis = WIDTHBYTES(lpbi->biWidth*lpbi->biBitCount) * lpbi->biHeight;
   ret = WideCharToMultiByte( CP_ACP, // UINT CodePage,            // code page
      0, // DWORD dwFlags,            // performance and mapping flags
      pf,   // LPCWSTR lpWideCharStr,    // wide-character string
      (int)len,     // int cchWideChar,          // number of chars in string.
      ps,      // LPSTR lpMultiByteStr,     // buffer for new string
      256,    // int cbMultiByte,          // size of buffer
      NULL,    // LPCSTR lpDefaultChar,     // default for unmappable chars
      NULL );  // LPBOOL lpUsedDefaultChar  // set when default char used
   ps[len] = 0;

   // CREATE the OUTPUT FILE
   fh = fopen( ps, "wb" );
   if( fh )
   {
      // Lock down the DIB
      //if( lpbi = (LPBITMAPINFOHEADER)DVGlobalLock( hDIB ) )  // LOCK DIB HANDLE
      if(lpbi)
      {
         // Fill in the fields of the file header
         ZeroMemory( &hdr, sizeof(BITMAPFILEHEADER) );
         hdr.bfType		 = DIB_HEADER_MARKER;
         hdr.bfReserved1 = 0;
         hdr.bfReserved2 = 0;
         hdr.bfOffBits   = (DWORD)sizeof(BITMAPFILEHEADER) +   // file header plus
                              lpbi->biSize +    // size of 	LPBITMAPINFOHEADER
                              PaletteSize((LPSTR)lpbi ); // plus PALETTE (if any)
         hdr.bfSize		 = dws + sizeof (BITMAPFILEHEADER);
         // write header to file
         //if( DVWrite( fh, (LPSTR)&hdr, sizeof(BITMAPFILEHEADER)) == sizeof( BITMAPFILEHEADER ) )
         if( fwrite( &hdr, 1, sizeof(BITMAPFILEHEADER), fh ) ==
            sizeof( BITMAPFILEHEADER ) ) {
            if( fwrite( lpbi, 1, dws, fh ) == dws ) {
               // if( DVWrite( fh, (LPSTR)lpbi, dws) == dws  )
               // written DIB to file
               flg = TRUE;
            }
      		//DVGlobalUnlock( hDIB ); // UNLOCK DIB HANDLE
         }
      }
      fclose(fh);
   }

   MFREE(ps);
   return flg;
}

// eof - testWrite.cxx
